Hi, I’d like to introduce a simple trick about segment tree in this blog as I promised in this comment. Sorry for the long delay, as a sophomore in Peking University, I've just finished a tired semester and a painful final exam. And now I finally have enough time to do a simple introduction to this interesting algorithm.

It may be a huge project for me since my English is not good. I think I will finish this blog in several steps and I will try to finish it as soon as possible :)

In China, all of the 15 candidates for the Chinese National Team are asked to write a simple research report about algorithms in informatics Olympiad, and the score will be counted in the final selection. There are many interesting ideas and algorithms in these reports. And I find that some of them are quite new for competitors in CF although they are well known in China from the final standings of some recent contests. For example, In the last contest CF Round #458, the problem G can be easily solved using "power series beats" (Thanks for matthew99 to give this name :)) in *O*(2^{n}*n*^{2}) which was imported in China by vfleaking in 2015.

This blog is about my report which is written about two years ago. I am satisfied with this work although there is a flaw about time complexity. xyz111 gave me a lot of inspiration, and the name “Segment tree beats” is given by C_SUNSHINE which is from a famous Japanese anime “Angel Beats”.

Here is the link about the Chinese version of this report.

### Part1. What it can do.

This work has two parts:

- Transform interval max/min (for ) operations into interval add/subtract operations in
*O*(1) or - Transform history max/min/sum queries into interval max/min operations in
*O*(1).

Here are some sample problems I used in my report. At first you have a array *A* of length *n* and two auxiliary arrays *B*, *C*. Initially, *B* is equal to *A* and *C* is all zero.

**Task 1**. There are two kinds of operations:

- For all , change
*A*_{i}to*max*(*A*_{i},*x*) - Query for the sum of
*A*_{i}in [*l*,*r*]

It can be solved in

**Task 2**. We can add more operations to Task 1:

- For all , change
*A*_{i}to*max*(*A*_{i},*x*) - For all , change
*A*_{i}to*min*(*A*_{i},*x*) - For all , change
*A*_{i}to*A*_{i}+*x*,*x*can be a negative number - Query for the sum of
*A*_{i}in [*l*,*r*]

It can be solved in and I could not proved the exact time complexity yet, maybe It is still ;)

**Task 3**. And we can query for some other things:

- For all , change
*A*_{i}to*max*(*A*_{i},*x*) - For all , change
*A*_{i}to*min*(*A*_{i},*x*) - For all , change
*A*_{i}to*A*_{i}+*x*,*x*can be a negative number - Query for the sum of
*B*_{i}in [*l*,*r*]

After each operation, for each *i*, if *A*_{i} changed in this operation, add 1 to *B*_{i}.

It’s time complexity is the same as Task 2.

**Task 4**. We can also deal with several arrays synchronously. Assume there are two arrays *A*_{1} and *A*_{2} of length *n*.

- For all , change
*A*_{a, i}to*min*(*A*_{a, i},*x*) - For all , change
*A*_{a, i}to*A*_{a, i}+*x*,*x*can be a negative number - Query for the max
*A*_{1, i}+*A*_{2, i}in [*l*,*r*]

It can be solved in and if there are *k* arrays, the time complexity will be raised to .

**Task 5**. And there are some tasks about historic information.

- For all , change
*A*_{i}to*A*_{i}+*x*,*x*can be a negative number. - Query for the sum of
*B*_{i}in [*l*,*r*]. - Query for the sum of
*C*_{i}in [*l*,*r*]

After each operation, for each *i*, change *B*_{i} to *max*(*B*_{i}, *A*_{i}) and add *A*_{i} to *C*_{i}.

The query for *B*_{i} can be solved in and the query for *C*_{i} can be solved in .

**Task 6**. We can even merged the two parts together.

- For all , change
*A*_{i}to*max*(*A*_{i},*x*) - For all , change
*A*_{i}to*A*_{i}+*x*,*x*can be a negative number. - Query for the sum of
*B*_{i}in [*l*,*r*].

After each operation, for each *i*, change *B*_{i} to *min*(*B*_{i}, *A*_{i}).

It can be solved in .

There are 11 sample tasks in my report and here are 6 of them. All of them are interesting and are hard to solve using the traditional techniques such as lazy tags.

### Part2. The main idea

#### Interval min/max operations

To make the description clearer, I think it’s better to introduce an extended segment tree template.

I think most of the competitors’ templates of the lazy tag is like this ([*l*, *r*] is the node's interval and [*ll*, *rr*] is the operation's interval):

```
void modify(int node, int l, int r, int ll, int rr) {
if (l > rr || r < ll) return;
if (l >= ll && r <= rr) {
puttag(node); return;
}
pushdown(node);
int mid = (l + r) >> 1;
modify(node * 2, l, mid, ll, rr);
modify(node * 2 + 1, mid + 1, r, ll ,rr);
update();
}
```

The main idea is **return whenever we can, put the tag whenever we can**:

- When the operation's interval and the node's interval are no longer intersected, the information inside this subtree must not be affected. So we can return immediately.
- When the node's interval is contained by the operation's interval, all the information inside the subtree will be changed together. So we can put the tag on it and return.

In other words, we can replace the two conditions arbitrarily, i.e., we can extend the template like this:

```
void modify(int node, int l, int r, int ll, int rr) {
if (break_condition()) return;
if (tag_condition()) {
puttag(node); return;
}
pushdown(node);
int mid = (l + r) >> 1;
modify(node * 2, l, mid, ll, rr);
modify(node * 2 + 1, mid + 1, r, ll ,rr);
update();
}
```

What's the use of such a modification? In some advanced data structure tasks, it's impossible for us to put tags in such a weak condition `l >= ll && r <= rr`

. But we can put it when the condition is stronger. We can use this template to deal with this kind of tasks but we need to analyze the time complexity carefully.

**Simple task:** There are three kinds of operations:

- For all , change
*A*_{i}to - For all , change
*A*_{i}to*x* - Query for the sum of
*A*_{i}in [*l*,*r*]

It's a classic problem (it's the simple extension of 438D - The Child and Sequence) and the traditional solution is to use balanced tree such as splay/treap to maintain the continuous segments with the same *A*_{i} and for operation 2, we find out all the segments with *A*_{i} ≥ *x* and change the value of each one.

But if we use segment tree, we can get a much simpler solution: let `break_condition`

be `l > rr || r < ll || max_value[node] < x`

and let `tag_condition`

be `l >= ll && r <= rr && max_value[node] == min_value[node]`

. And we can find that the time complexity of this segment tree is also .

And now, we can easily describe the main idea of "segment tree beats". For each node, we maintain the maximum value `max_value[node]`

and the strict second maximum value `second_value[node]`

.

When we are doing the interval min operation for number *x*. let `break_condition`

be `l > rr || r < ll || max_value[node] <= x`

and let `tag_condition`

be `l >= ll && r <= rr && second_value[node] < x`

. Under such an condition, after put this tag, all of the maximum values inside this subtree will be changed to *x* and they are still the maximum values of this subtree.

To make it easier to merge with other operations, we can maintain the values in this way: For each node, we maintain the maximum value inside this subtree and other values separately (the maximum values are the first kind and others are the second). Then, interval max operation will be changed to "add a number to the first kind values in some intervals". Keep the meanings of each kinds of values and the tags, you will find that the processes of pushdown and update will be much clearer.

That's the main idea of the first part of "segment tree beats". It is very simple, right? And it also has a very nice time complexity. (I will give out the proof of the time complexity in the third part of this article).

And let's see the first two sample tasks in part 1.

**Task 1**. In this task, we can maintain the number of the first kind of values inside each node `t[node]`

, and when we put tag "add *x* to the first kind values in this subtree", the sum will be added by `t[node] * x`

. Then we can easily maintain the information we need.

**Task 2**. In this task, we can maintain the maximum values/ minimum values and others separately, i.e., there are three kinds of numbers now, and we will use three sets of tags for each kind of values. Also, to deal with the queries of the interval's sum, we need to maintain the numbers of the first kind and the second kind of values. Pay attention to some boundary conditions, if there are just two different values in this subtree, there will be no third kind of values and if all the values are the same, the set of the first kind and the second kind will be the same

#### Historic information

In this part, we will focus on three special values which I named "historic information":

- historic maximal value: after each operation, change
*B*_{i}to*max*(*B*_{i},*A*_{i}) - historic minimal value: after each operation, change
*B*_{i}to*min*(*B*_{i},*A*_{i}) - historic sum: after each operation, add
*C*_{i}by*A*_{i}.

You may wonder why we need to consider these values. But in China, there had been several problems about these values before I wrote this report. And maintaining these values is a much harder task than it looks like. Here is a data structure task in Tsinghua University Training 2015:

**Sample Task**: Here is the link of this problem. There are five kinds of operations (*x* is a positive integer.):

- For all , change
*A*_{i}to*A*_{i}+*x*. - For all , change
*A*_{i}to*max*(*A*_{i}-*x*, 0). - For all , change
*A*_{i}to*x*. - Query for
*A*_{i}. - Query for
*B*_{i}.

After each operation, change *B*_{i} to *max*(*B*_{i}, *A*_{i}).

To solve this task, ordinary segment tree is enough. But It's not easy to deal with the relationship between the lazy tags and the historic information. Since I do not have enough time to write today, I will update the solution later.

We have already gotten the way to deal with the interval min/max operations. And they are good tools to maintain historic information.

Now, let use consider such a kind of problems (Part1. Task 5): interval add/subtract, query for the interval sum of historic information. It's quite hard since we can't just use the traditional lazy tag technique to solve it. But we can use an auxiliary array *D*_{i} with the initial value of all zero to do some transformation:

- Historic maximal value: let
*D*_{i}=*B*_{i}-*A*_{i}. Then if we change*A*_{i}to*A*_{i}+*x*,*D*_{i}will be changed to*max*(*D*_{i}-*x*, 0). - Historic minimal value: let
*D*_{i}=*B*_{i}-*A*_{i}. Then if we change*A*_{i}to*A*_{i}+*x*,*D*_{i}will be changed to*min*(*D*_{i}-*x*, 0). - Historic sum: let
*D*_{i}=*C*_{i}-*tA*_{i}while*t*is the current operation id. Then if we change*A*_{i}to*A*_{i}+*x*,*D*_{i}will be changed to*D*_{i}- (*t*- 1)*x*.

We can use the technique introduced in the previous part about interval min/max operations to maintain the sum of *D*_{i}. And then we could get the sum of *B*_{i} or *C*_{i}.

What's more, since we have already transformed interval min/max operations to interval add/subtract operations, we can also maintain the interval sum of historic information under interval min/max operations (Part1. Task 6). This is a simple expansion and I think it's better to leave it as an exercise.

That's all the main idea of "segment tree beats". And I will add the proof about time complexity in the next update. It's a little hard for me to explain the proof in English so maybe it will take me some time to form words. I think that will be the last update, and I will try to finish it soon :).

I've never thought that this article will be so popular. Thanks a lot for the encouragement and the support!